-- Dump of first_boot
-- Generated on Wed, 22 Feb 2012 02:03:49 GMT
Library work;
    use work.yasep_definitions.all;
    use work.yasep_utils.all;
Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;

entity SynchRam16 is
 port(
  clk, reset: in std_logic;
  NPC: in SLVAI;
  RAM_out: out SLV16);
end SynchRam16;

architecture first_boot of SynchRam16 is
  type RAM_array_type is array(0 to 52) of integer;
  constant RAM_array : RAM_array_type := (
 -- .name sequence1
 -- .profile microYASEP
 16#1009#, 16#1234#, -- mov 1234h R1
 16#4009#, 16#5678#, -- mov 5678h R4
 16#1115#, 16#4321#, -- ADD 4321h R1
 16#1117#, 16#0100#, -- ADD R1 R1 R1
 16#220A#, -- mov 2 R2
 16#330A#, -- mov 3 R3
 16#2408#, -- mov R2 R4
 16#3408#, -- mov R3 R4
 16#1317#, 16#0400#, -- add  R1 R3 R4
 16#0009#, 16#0038#, -- mov 56 PC
 16#2337#, 16#0400#, -- sub  R2 R3 R4
 16#4315#, 16#1234#, -- add  1234h R3 R4
 16#4335#, 16#1234#, -- sub  1234h R3 R4
 16#3237#, 16#0400#, -- sub  R3 R2 R4
 16#2313#, 16#0400#, -- and  R2 R3 R4
 16#0015#, 16#0008#, -- ADD 8 PC
 16#0009#, 16#0020#, -- mov 32 PC
 16#2333#, 16#0400#, -- andn R2 R3 R4
 16#4311#, 16#1234#, -- and  1234h R3 R4
 16#4331#, 16#1234#, -- andn 1234h R3 R4
 16#2353#, 16#0400#, -- nand R2 R3 R4
 16#2373#, 16#0400#, -- or   R2 R3 R4
 16#2393#, 16#0400#, -- orn  R2 R3 R4
 16#23B3#, 16#0400#, -- nor  R2 R3 R4
 16#23D3#, 16#0400#, -- xor  R2 R3 R4
 16#23F3#, 16#0400#, -- xorn R2 R3 R4
 16#3460#, -- PUT R3 R4
 16#3440#, -- GET R3 R4
 16#7362#, -- PUT R3 7
 16#000A#, -- MOV 0 PC
 16#FFFF# );

begin
  process(clk ,reset)
    variable adr, dat: integer;
  begin
    if reset/='1' then
      RAM_out <= (RAM_out'range=>'0');
    else
      if rising_edge(clk) then
        adr := safe_to_integer(NPC);
        if adr < 0 or adr >= RAM_array'length then
          report " Accessing instruction beyond limit at " & integer'image(adr);
          dat:=0;
        else
          dat := RAM_array(adr);
--          report " Lecture @ " & integer'image(adr)
--                       & " : " & integer'image(dat) ;
        end if;
        RAM_out <= std_logic_vector(to_unsigned(dat,16));
--      RAM_out <= std_logic_vector(to_unsigned(RAM_array(to_integer(unsigned(NPC))),16));
      end if;
    end if;
  end process;
end first_boot;
