-- test_Y.vhd
-- created mar. févr. 21 14:26:03 CET 2012 by whygee@f-cpu.org

-- à tester :
-- écriture et lecture de tous les registres et vérifier PC
--   vérifier DST
-- extension de signe
-- toutes les formes
-- tous les opcodes
-- toutes les unités : XOR KO ?
-- toutes les conditions : ok


Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
library work;
    use work.yasep_definitions.all;
    use work.yasep_utils.all;

entity test_uY is
  -- empty
end test_uY;

architecture toplevel of test_uY is
  signal WR_en  : std_logic := '0';
  signal WB_en  : std_logic := '0';
  signal phase  : std_logic := '0';
  signal clk    : std_logic := '0';
  signal reset  : std_logic := '0';
  signal CARRY  : std_logic := '0';
  signal FlagZero : std_logic := '0';
  signal condR1 : integer := 45;
  signal condition  : std_logic := '0';
  signal Condition2  : std_logic := '0';
  signal Field_cond, Field_SI4, Field_SND : SLV4 := "0000";

  signal PC : SLVAI := (SLVAI'range => '0');
  signal NPC : SLVAI := (SLVAI'range => '0');
  signal RAM_out : SLV16 := (SLV16'range => '0');
  signal DST : SLV4 := "0000";

  signal GetReadPort, PutWritePort, SRaddress: SLVY := (SLVY'range => '0');
  signal GET_en  : std_logic := '0';
  signal PUT_en  : std_logic := '0';
  signal INV  : std_logic := '0';

--  signal flag_addr : SLV4 := "0000";
--  signal flags_in  : std_logic := '0';
  signal A1_en : std_logic := '0';
  signal R1, R2, R3, R4, R5, Result: SLVY := (SLVY'range => '0');

begin
  ProgRAM:
    entity work.SynchRam16
    port map(
      clk => clk,
      reset => reset,
      NPC => NPC,
      RAM_out => RAM_out);

  uY:
    entity work.microYASEP
    port map(
      NPC => NPC,
      PC => PC,
      RAM_out => RAM_out,
      DST => DST,
      phase => phase,
      WB_en => WB_en,
      WR_en => WR_en,
      Carry => CARRY,
      FlagZero => FlagZero,
      Condition2 => Condition2,
      Condition => Condition,
--      condR1 => condR1,
      Field_cond => Field_cond,
      Field_SI4 => Field_SI4,
      Field_SND => Field_SND,
      R1 => R1,
      R2 => R2,
      R3 => R3,
      R4 => R4,
      R5 => R5,
      INV => INV,
      GetReadPort => GetReadPort,
      PutWritePort =>  PutWritePort,
      SRaddress => SRaddress,
      GET_en => GET_en,
      PUT_en => PUT_en,

--      flag_addr => flag_addr,
--      flags_in  => flags_in,
--      A1_en => A1_en,
--      D1 => D1,
      Result => Result,

      clk => clk,
      ext_reset => reset);

  observe: process(clk) begin
    if clk='1' then -- and phase='1' then
      report " phase="     & std_logic'image(phase)
           & " WR_en="     & std_logic'image(WR_en)
           & " CARRY="     & std_logic'image(CARRY)
           & " EQ="        & std_logic'image(FlagZero)
           & " cond="     & std_logic'image(condition)
           & " cond2="     & std_logic'image(Condition2)
--           & " cR1="     & integer'image(condR1)
--           & " Fcond="     & SLV_to_Hex(Field_cond)
--           & " WB_en="     & std_logic'image(WB_en)
--           & " GET_en="    & std_logic'image(GET_en)
--           & " PUT_en="    & std_logic'image(PUT_en)
--           & " A1_en="     & std_logic'image(A1_en)
         & "   PC="        & SLV_to_Hex(PC & '0')
          & "  NPC="       & SLV_to_Hex(NPC & '0')
          & "  RAM_out="   & SLV_to_Hex(RAM_out)
          & "  Result="    & SLV_to_Hex(Result)
          & " DST="       & SLV4_to_Hex(DST)
         & "  R1="        & SLV_to_Hex(R1)
          & " R2="        & SLV_to_Hex(R2)
          & " R3="        & SLV_to_Hex(R3)
          & " R4="        & SLV_to_Hex(R4)
          & " R5="        & SLV_to_Hex(R5)
--          & "  SRaddress=" & SLV_to_Hex(SRaddress)
--          & "  D1="        & SLV_to_Hex(D1)
--         & " "         & integer'image(safe_to_integer())
      ;
    end if;
  end process;

  bench: process
    variable i: integer := 0;
  begin
                wait for 1 us;
    clk <= '1'; wait for 1 us;
    clk <= '0'; wait for 1 us;
    clk <= '1'; wait for 1 us;
    clk <= '0'; wait for 1 us;

    report " *** releasing reset *** ";
    reset <= '1'; wait for 1 us;

    while i < 200 loop
      clk <= '1'; wait for 1 us;
      clk <= '0'; wait for 1 us;
      i:=i+1;
      if INV='1' then
        if (R5="1101111010101101") then -- DEADh ?
          report "Simulation failed : testbench error at " & SLV_to_Hex(R4) & "h";
        else
          if (R5="0110000000001101") then -- GOOD ?
            report "Simulation succeeded";
          else
            report "Simulation stopped : Invalid instruction";
          end if;
        end if;
        wait;
      end if;
    end loop;

    wait;
  end process;

end toplevel;
